backend/models/Offers.php
<?php

namespace backend\models;

use common\models\User;
use Symfony\Component\BrowserKit\History;
use Yii;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;
use yii\db\Expression;
use backend\models\History as OfferHistory;
/**
 * This is the model class for table "Offers".
 *
 * @property int $id
 * @property int $client_id
 * @property string $date
 * @property string $status
 * @property int $city
 * @property int $division
 * @property int $responsible
 * @property int $source
 * @property string $credit_summ
 * @property string $comment
 * @property string $updated_at
 */
class Offers extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'offers';
    }

    public function afterSave($insert, $changedAttributes)
    {
       /* if ($insert) {
            Yii::$app->session->setFlash('success', 'Запись добавлена');
        } else {
            Yii::$app->session->setFlash('success', 'Запись обновлена');
        }*/

        if ($insert) {
            $history = new OfferHistory();
            $history->offer_id = $this->id;
            $history->user_id = Yii::$app->user->identity->id;

            $history->action = "created";
            $history->save();
        }

       if(isset($changedAttributes['division']) && $changedAttributes['division'] != $this->division) {
           $history = new OfferHistory();
           $history->offer_id = $this->id;
           $history->user_id = Yii::$app->user->identity->id;

           $history->old_department_id = $changedAttributes['division'];
           $history->new_department_id = $this->division;
           $history->action = "change_department";

           $history->save();
       }

       if(isset($changedAttributes['status']) && $changedAttributes['status'] != $this->status) {
           $history = new OfferHistory();
           $history->offer_id = $this->id;
           $history->user_id = Yii::$app->user->identity->id;

            $history->old_status_id = $changedAttributes['status'];
            $history->new_status_id = $this->status;
            $history->action = "change_status";

           $history->save();
       }

        if(array_key_exists('responsible', $changedAttributes) && $changedAttributes['responsible'] != $this->responsible) {
            $history = new OfferHistory();
            $history->offer_id = $this->id;
            $history->user_id = Yii::$app->user->identity->id;
            $history->old_responsible_id = $changedAttributes['responsible'] ? $changedAttributes['responsible'] : 0;
            $history->new_responsible_id = $this->responsible;
            $history->action = "change_responsible";

            $history->save();
        }

        parent::afterSave($insert, $changedAttributes);
    }

    public function beforeSave($insert)
    {
        if (parent::beforeSave($insert)) {

            if($this->status == 13) {
                $this->division = 8;
            }
            if($this->status == 26) {
                $this->division = 7;
            }

            return true;
        }
        return false;
    }

    public function behaviors(){
        return [
            [
                'class' => TimestampBehavior::className(),
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_INSERT => ['date'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['updated_at'],
                ],
                // если вместо метки времени UNIX используется datetime:
                'value' => new Expression('NOW()'),
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['client_id', 'city', 'division', 'responsible'], 'integer'],
            [['date'], 'safe'],
            [['updated_at'], 'safe'],
            [['status', 'credit_summ'], 'string', 'max' => 255],
            [['status'], 'default', 'value' => '25'],
            [['comment'], 'string'],
            [['source'], 'default', 'value' => '2'],
            [['division'], 'default', 'value' => '6']

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'client_id' => 'ID Клиента',
            'date' => 'Дата',
            'status' => 'Статус',
            'city' => 'Город',
            'division' => 'Отдел',
            'responsible' => 'Ответственный',
            'source' => 'Источник',
            'credit_summ' => 'Сумма кредита',
            'comment' => 'Комментарий'
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getClient()
    {
        return $this->hasOne(Clients::className(), ['id' => 'client_id']);
    }

    public function getStatusname()
    {
        return $this->hasOne(Status::className(), ['id' => 'status']);
    }

    public function getCityname()
    {
        return $this->hasOne(Cities::className(), ['id' => 'city']);
    }

    public function getDepartment()
    {
        return $this->hasOne(Departments::className(), ['id' => 'division']);
    }

    public function getResponsibleName()
    {
        return $this->hasOne(User::className(), ['id' => 'responsible']);
    }

    public function getSourcename()
    {
        return $this->hasOne(Source::className(), ['id' => 'source']);
    }

    public function getServices()
    {
        return $this->hasMany(Services::className(), ['offer_id' => 'id']);
    }

    public function getActions()
    {
        return $this->hasMany(Action::className(), ['offer_id' => 'id'])->orderBy(['datetime'=>SORT_DESC]);
    }

    public function getHistory()
    {
        return $this->hasMany(OfferHistory::className(), ['offer_id' => 'id'])->orderBy(['date'=>SORT_DESC]);
    }

    public function getComments()
    {
        return $this->hasMany(Comments::className(), ['offer_id' => 'id']);
    }
}

backend/controllers/StatisticController.php
<?php

namespace backend\controllers;

use backend\models\Departments;
use backend\models\History;
use backend\models\Offers;
use backend\models\Status;
use common\models\User;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use Yii;

class StatisticController extends \yii\web\Controller
{
	/**
	 * {@inheritdoc}
	 */
	public function behaviors()
	{
		return [
			'verbs' => [
				'class' => VerbFilter::className(),
				'actions' => [
					'delete' => ['POST'],
				],
			],
			'access' => [
				'class' => AccessControl::className(),
				'rules' => [
					[
						'allow' => true,
						'roles' => ['viewFunnel'],
					],
				],
			],
		];
	}

    public function actionIndex()
    {

		$statistic = [];
	    $filters = [];
	    $employee = ArrayHelper::map(User::find()->all(), 'id', 'fullname');

	    $departments = Departments::find()->all();

	    if(Yii::$app->request->get("Filters")) {

		    $date_period = Yii::$app->request->get("Filters")['date'];
		    $employee_id = Yii::$app->request->get("Filters")['employee'];
		    $filters['date'] = $date_period;
		    $filters['employee'] = $employee_id;

		    $date_period = explode(" - ", $date_period);
		    $date_from = $date_period[0];
		    $date_to = $date_period[1];

		    $createdDateFrom = \DateTime::createFromFormat('d.m.Y H:i:s', $date_from. ' 00:00:00');

		    $createdDateTo = \DateTime::createFromFormat('d.m.Y H:i:s', $date_to . ' 23:59:59');

		    foreach ( $departments as $department ) {
			    if($filters['employee']) {
				    $users = User::find()->where(["department_id" => $department->id, "id" => $employee_id])->all();
			    } else {
				    $users = User::find()->where(["department_id" => $department->id])->all();
			    }
			    foreach ($users as $user) {
				    $offers_count = History::find()
				                           ->where(["new_responsible_id" => $user->id])
				                           ->andFilterWhere(['>=', 'date', $date_from ? $createdDateFrom->format('Y-m-d H:i:s') : null])
				                           ->andFilterWhere(['<=', 'date', $date_to ? $createdDateTo->format('Y-m-d H:i:s') : null])
				                           ->count();

				    $statistic[$department->name][$user->fullname]["offers_count"] = $offers_count;
				    $statuses = Status::find()->where(["department_id" => $department->id])->all();
				    foreach ($statuses as $status) {

					    $status_offers = History::find()
					                            ->where(["user_id" => $user->id, "new_status_id" => $status->id])
					                            ->andFilterWhere(['>=', 'date', $date_from ? $createdDateFrom->format('Y-m-d H:i:s') : null])
					                            ->andFilterWhere(['<=', 'date', $date_to ? $createdDateTo->format('Y-m-d H:i:s') : null]);

					    $offers = $status_offers->select('id')->asArray()->column();


					    $statistic[$department->name][$user->fullname]["statuses"][$status->status_name]["count"] = $status_offers->count();
					    $statistic[$department->name][$user->fullname]["statuses"][$status->status_name]["offers"] = $offers;
				    }

			    }
		    }

	    } else {

		    foreach ( $departments as $department ) {
			    $users = User::find()->where(["department_id" => $department->id])->all();

			    foreach ($users as $user) {
				    $offers_count = History::find()->where(["new_responsible_id" => $user->id])->count();
				    $statistic[$department->name][$user->fullname]["offers_count"] = $offers_count;

				    $statuses = Status::find()->where(["department_id" => $department->id])->all();
				    foreach ($statuses as $status) {

					    $status_offers = History::find()->where(["user_id" => $user->id, "new_status_id" => $status->id]);
					    $offers = $status_offers->select('offer_id')->asArray()->column();

					    $statistic[$department->name][$user->fullname]["statuses"][$status->status_name]["count"] = $status_offers->count();
					    $statistic[$department->name][$user->fullname]["statuses"][$status->status_name]["offers"] = $offers;
				    }

			    }
		    }

	    }



        return $this->render('index',[
        	"users" => $users,
        	"statistic" => $statistic,
	        'filters' => $filters,
	        'employee' => $employee
        ]);
    }

	public function actionStatusOffers() {
    	$offers_ids = Yii::$app->request->get();

    	$offers = Offers::find()->where(["IN","id", $offers_ids['offers_ids']])->all();
		return $this->renderPartial('status-offers', [
			'offers' => $offers
		]);
	}

}

backend/views/statistic/_search-statistic.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\models\PaymentsSearch */
/* @var $form yii\widgets\ActiveForm */
?>
<?php $form = ActiveForm::begin([
    'action' => ['index'],
    'method' => 'get',
]);?>
<div class="offers-filters">
    <div class="container-fluid no-paddings">
        <div class="row">
            <div class="col-md-3">
                <label for="date">Период</label>
                <?= Html::textInput("Filters[date]", $filters['date'], ["class"=>"form-control", "id"=>"date", 'autocomplete' => 'off']) ?>

            </div>
            <div class="col-md-3">
                <label for="city_id">Сотрудник</label>
		        <?= Html::dropDownList("Filters[employee]",$filters['employee'], $employee,["class"=>"form-control", "prompt" => "Все"] ) ?>
            </div>
            <div class="col-md-3">
                <div class="form-group" style="padding-top: 24px">
                    <?= Html::submitButton('Применить', ['class' => 'btn btn-primary']) ?>
                    <?= Html::a('Сброс',['index'],['class' => 'btn btn-warning']) ?>
                </div>
            </div>
        </div>

    </div>
</div>
<?php ActiveForm::end(); ?>

backend/views/statistic/index.php
<?php
/* @var $this yii\web\View */
$this->title = 'Воронка продаж';
$this->params['breadcrumbs'][] = $this->title;
?>
<?php echo $this->render('_search-statistic', [
	'filters' => $filters,
    'employee' => $employee
]);


?>

<div class="statistic">
<?php


foreach ($statistic as $department=>$users): ?>
    <h4><?= $department ?></h4>
    <?php foreach ($users as $name=>$user):?>
        <details>
            <summary><?=$name?>. Сделок: <?= $user['offers_count'] ?></summary>
            <div class="details-inner">
				<?php foreach ($user['statuses'] as $status_name => $status):?>
                    <div class="statistic__status-item">
						<?= $status_name ?> - <a class="status_offers_btn" href="/statistic/status-offers" data-offers='<?= json_encode($status['offers'],  JSON_UNESCAPED_UNICODE | JSON_NUMERIC_CHECK) ?>'><?= $status['count'] ?></a>
                    </div>


				<?endforeach; ?>
            </div>
        </details>
     <?endforeach;?>

<?endforeach?>

<div class="status__offers modal fade">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                <h4 class="modal-title">Сделки </h4>
            </div>
            <div class="modal-body box-body table-responsive no-padding">

            </div>
        </div>
    </div>
</div>

</div>

backend/views/statistic/status-offers.php
<?php
/**
 * Created by PhpStorm.
 * User: g
 * Date: 02.11.2019
 * Time: 19:56
 */
?>

<table class="table table-bordered">
	<thead class="thead">
	<tr>
		<td>
			ID
		</td>
		<td>
			Статус
		</td>
		<td>
			Последнее изменение
		</td>
		<td>
			Клиент
		</td>
		<td>
			Сотрудник
		</td>
	</tr>
	</thead>
	<tbody>
	<?php foreach($offers as $offer): ?>
	<tr>
		<td>
            <a href="<?=Yii::$app->urlManager->createUrl(['offers/view', 'id' => $offer->id])?>"><?= $offer->id ?></a>
		</td>
		<td>
			<?= $offer->statusname->status_name ?>
		</td>
		<td>
            <?= $offer->updated_at ? date('d.m.Y',strtotime($offer->updated_at)) : "Не задано"?>
		</td>
        <td>
            <?= $offer->client->name ?>
        </td>
		<td>
			<?= $offer->responsibleName->fullname ?>
		</td>
	</tr>
	<?endforeach;?>
	</tbody>
</table>